//Ǽ

#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#define Nrhoc 20
#define drhoc 0.1//±Ĭܶ18*10^17 
#define dt 0.001

//q 
double q(double t){
	double sum;
	sum=1.9*(sinh(t)-8.0*sinh(0.5*t)+3.0*t);
	return(sum);
}

//dq/dt
double dq(double t){
	double sum;
	sum=1.9*(cosh(t)-4.0*cosh(0.5*t)+3.0);
	return(sum);
}

//rho 
double rho(double t){
	double sum;
	sum=5.71*(sinh(t)-t);
	return(sum);
}
 
//ͨrhoctc
double tc(double rhoc){
	double t,r;
	int i=0;
	do{
		t=(double)i*dt;
		r=rho(t);
		i=i+1;
	}while(r<rhoc);
	return(t);
}

//tԤ
double tpre(double r,double t0,double m0,double dr){
	double t;
	t=t0-(m0+1.256*pow(r,3.0)*q(t0))*(rho(t0)+q(t0))*(dr*0.5)/(r*(13.493*r-2.0*m0)*dq(t0));
	return(t);
} 

//mԤ
double mpre(double r,double t0,double m0,double dr){
	double m;
	m=m0+1.256*pow(r,2.0)*rho(t0)*(dr*0.5);
	return(m);
}

//tУ
double tcor(double r,double t0,double tpre,double mpre,double dr){
	double t;
	t=t0-(mpre+1.256*pow(r,3.0)*q(tpre))*(rho(tpre)+q(tpre))*dr/(r*(13.493*r-2.0*mpre)*dq(tpre));
	return(t);
} 

//mУ
double mcor(double r,double tpre,double m0,double dr){
	double m;
	m=m0+1.256*pow(r,2.0)*rho(tpre)*dr;
	return(m);
}

// 
void output(double rhoc,double dr,FILE *fp){
	double r,t,m=0.0;
	t=tc(rhoc);
	double thalf,mhalf,t1,m1;
	int i=0;
	do{
		r=(double)i*dr;
		if(i==0){
			r=0.5*dr;//0 
		}
		thalf=tpre(r,t,m,dr);
		mhalf=mpre(r,t,m,dr);
		if(thalf<=0.0){
			t=thalf;
			m=mhalf;
			break;
		}
		r=r+0.5*dr;
        t=tcor(r,t,thalf,mhalf,dr);
		m=mcor(r,thalf,m,dr);				
		i=i+1;
	}while(t>0.0);
	fprintf(fp,"%2.1f\t%2.10f\t%2.6f\n",log10(rhoc),-log(r),m);
}
 
//
int main(){
	double rhoc,dr;
	int i;
	FILE *fp;
	fp=fopen("data2.xlsx","w");
	for(i=0;i<=Nrhoc;i++){
		rhoc=pow(10.0,(double)i*drhoc);
		dr=pow(10.0,-6.0)*pow(rhoc,-1.0/3.0);
		output(rhoc,dr,fp);
	}
	fclose(fp);
	return(0);
} 
